package com.mesolabs.beans.learnerlab;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

/*
Create an abstract `People` class
	* The class signature should be parameterized with `PersonType` such that `PersonType` is a sub class of `Person`.
	* The class should implement `Iterable` of type `PersonType`.
	* Upon construction `People` should consume a `List` of `PersonType` and set it to a respective `personList` field.
	* The class should define a constructor which consumes a variable number of `PersonType` objects and sets the `personList` field respectively.
	* The class should define a method named `add` which adds a `PersonType` to the `personList`.
	* The class should define a method named `remove` which removes a `PersonType` from the `personList`.
	* The class should define a method named `size` which returns the size of `personList`.
	* The class should define a method named `clear` which clears our `personList` field.
	* The class should define a method named `addAll` which adds an `Iterable` of `PersonType` objects to the composite `personList`.
		* This method will **NOT** take an argument of `Collection<PersonType>`
	* The class should define a method named `findById` which makes use of a `long id` parameter to return a `PersonType` object with the respective `id` field.
	* The class should define a method named `findAll` which returns the composite `personList`.
 */
//Iterable<? extends Learner> learners
public abstract class People<Persontype extends Person>  implements Iterable <Persontype> {

    List<Persontype> list;

    //ArrayList<Person> personList;

    public People(Persontype  plist) {
        this.list = new ArrayList<Persontype>(Arrays.asList(plist));
    }

    public void addPerson(Persontype e) {

        list.add(e);
    }

    public int size() {
        return list.size();
    }

    public void removes(Persontype e) {
        list.remove(e);
    }

    public void clear() {
        list.clear();
    }

    public void addAll(Iterable<Persontype> p) {
        for (Persontype person : p) list.add(person);
    }

    public Persontype findById(long id) {
        for(Persontype p : list){
            if(p.getId() == id){
                return p;
            }
        }
       return null;
        //return list.stream().filter(personList -> personList.getId().equals(id)).findFirst().get();

    }

    public List<Persontype> findAll() {
        return list ;
    }
    @Override
    public Iterator<Persontype> iterator() {
        return list.iterator();
    }
}

